Index: gs3-extensions/html-to-expeditee/trunk/src/src/cgi-bin/html-to-expeditee.pl.in
===================================================================
--- gs3-extensions/html-to-expeditee/trunk/src/src/cgi-bin/html-to-expeditee.pl.in	(revision 24920)
+++ gs3-extensions/html-to-expeditee/trunk/src/src/cgi-bin/html-to-expeditee.pl.in	(revision 24922)
@@ -115,20 +115,31 @@
   <head>
     <title>HTML to Expeditee Frames</title>
-    <link type="text/css" href="../ext/html-to-expeditee/jquery/css/le-frog/jquery-ui-1.8.16.custom.css" rel="stylesheet" />
-    <script type="text/javascript" src="../ext/html-to-expeditee/jquery/js/jquery-1.6.2.min.js"></script>
-    <script type="text/javascript" src="../ext/html-to-expeditee/jquery/js/jquery-ui-1.8.16.custom.min.js"></script>
-    <script type="text/javascript" src="../ext/html-to-expeditee/js/gsajax-min.js"></script>
-    <script type="text/javascript" src="../ext/html-to-expeditee/js/html-to-expeditee.js"></script>
+
+    <base href=".." />
+
+    <link type="text/css" href="ext/html-to-expeditee/jquery/css/le-frog/jquery-ui-1.8.16.custom.css" rel="stylesheet" />
+    <script type="text/javascript" src="ext/html-to-expeditee/jquery/js/jquery-1.6.2.min.js"></script>
+    <script type="text/javascript" src="ext/html-to-expeditee/jquery/js/jquery-ui-1.8.16.custom.min.js"></script>
+    <script type="text/javascript" src="ext/html-to-expeditee/js/gsajax-min.js"></script>
+    <script type="text/javascript" src="ext/html-to-expeditee/js/html-to-expeditee.js"></script>
+
+
 
   </head>
   <body>
-    <form>
-      Convert the collection <input type="text" name="collect" value="$collect" id="collect" />
-      to Expeditee frames by traversing the classifier <input type="text" name="cl" value="$cl" id="cl" />
-
-      <input value="$site" id="site" type="hidden">
-      <input value="Go" id="go" 
-             class="ui-button ui-widget ui-state-default ui-corner-all" 
-             type="submit">
+    <form class="ui-widget">
+      Convert the collection 
+        <input type="text" 
+	       class="ui-corner-all" style="padding: 4px;"
+	       name="collect" value="$collect" id="collect" />
+      to Expeditee frames by traversing the classifier 
+        <input type="text" 
+	       class="ui-corner-all" style="padding: 4px;"
+               name="cl" value="$cl" id="cl" />
+
+        <input value="$site" id="site" type="hidden">
+        <input value="Go" id="go" 
+               class="ui-button ui-widget ui-state-default ui-corner-all" 
+               type="submit">
 
     </form>
@@ -167,6 +178,7 @@
 	      }
 	      else {
-	          url = "../dev";
+	          url = "dev";
 	          url += "?c="+collect +"&a=b&rt=s&s=ClassifierBrowse&cl=" + cl;
+	          url += "&excerptid=gs_content";
 	      }
 
@@ -184,15 +196,7 @@
 		  		  
 		  var aElems;
-		  //if (gs2) {
-		      var workingTrav = document.getElementById("workingTraverse");
-		      workingTrav.innerHTML = clHtml;
-		      aElems = workingTrav.getElementsByTagName("a");
-		  //}
-		  //else {
-		      /* gs3 */
-		    //  var parser = new DOMParser();
-		     // cl_doc = parser.parseFromString(clHtml,"text/html");
-		     // var aElems = cl_doc.getElementsByTagName("a");
-		  //}
+		  var workingTrav = document.getElementById("workingTraverse");
+		  workingTrav.innerHTML = clHtml;
+		  aElems = workingTrav.getElementsByTagName("a");
 		  
 		  
@@ -235,7 +239,7 @@
 	     }
 	     else {
-	          url = "../dev";
+	          url = "dev";
 	          url += "?c="+collect +"&a=d&d=" + docOID;
-	          url += "&ed=1";
+	          url += "&ed=1&dt=hierarchy";
 	     }
 	      
@@ -282,5 +286,5 @@
 	      var site    = document.getElementById("site").value;
 
-	      var url = "html-to-expeditee.pl";
+	      var url = "cgi-bin/html-to-expeditee.pl";
 	      var params = "c=" + collect;
 	      if (site.match(/\\w/)) {
@@ -316,10 +320,8 @@
 	     	  }
 	     	  else {
-	              url = "../dev";
+	              url = "dev";
 	              url += "?c="+collect +"&a=d&d=" + docOID;
-	              url += "&ed=1";
+	              url += "&ed=1&dt=hierarchy";
 	     	  }
-
-
 
 		  iframe.src = url;